﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function AgeDataSelection( )
		SetDataFolder root:
			String/G G_Site
			String Site = G_Site, FldrList = SortList( FolderList( "*" ) )
			String Fldr, Age, Depth, Event
			Variable i
			Prompt Site, "Site:"
			DoPrompt "AgeDataSelection", Site
			G_Site = Site; AbortOnValue V_Flag, 0
		NewDataFolder/O/S AgeDepthFit
			Make/O/N = 0 $Site + "_AgeData_4_Fit", $Site + "_DepthData_4_Fit"  // Set up empty waves for age and depth. Selected data sets will be added below
			WAVE AgeWv4Fit = $Site + "_AgeData_4_Fit", DepthWv4Fit = $Site + "_DepthData_4_Fit" // Wave refs for combined age and depth waves
			Make/T/O/N = 0  $Site + "_DataType_4_Fit", DataTypeWv, $Site + "_DataEvent_4_Fit" // Set up empty text waves for type and event/species. Selected data sets will be added below
			WAVE/T Type4Fit = $Site + "_DataType_4_Fit", Event4Fit = $Site + "_DataEvent_4_Fit", DataTypeWv // Wave refs for combined type and event waves
			For( i = 0; 1; i += 1 ) // This loop keeps adding more data sets to the waves created above until the User stops
				Prompt Fldr, "Folder with age and depth waves to add for fitting:", popup, "root;" + FldrList // Get a folder with age/depth data
				DoPrompt "AgeDataSelection", Fldr; AbortOnValue V_Flag, 0 
		SetDataFolder	$"root:" + Fldr // Go to the selected folder holding age/depth data
				Prompt Age, "Select Age Wave:", popup, SortList( WaveList( "*", ";", "" ) ) 
				Prompt Depth, "Select Depth Wave:", popup, SortList( WaveList( "*", ";", "" ) )
				Prompt Event, "Select the Event wave:", popup, SortList( WaveList( "*", ";", "" ) )
				DoPrompt "AgeDataSelection", Age, Depth, Event; AbortOnValue V_Flag, 0
				WAVE/T EventWv = $Event // Wave ref for event wave
				Redimension/N = ( NumPnts( $Age ) ) DataTypeWv // Make the Type wave the same length as the other selected waves
				DataTypeWv = SecondPart( Age ) // Set the Type wave equal to the "Technique" of the Age wave. Waves should be named like U1338A_Nannos_Age, or U1338_Nannos_Age
				Concatenate/NP Age + ";", AgeWv4Fit // Add the selected Age data wave to the wave created to hold the combined ages
				Concatenate/NP Depth + ";", DepthWv4Fit // Add the selected Depth data wave to the wave created to hold the combined depthss
				Concatenate/T/NP {DataTypeWv} , Type4Fit // Add the selected Type data wave to the wave created to hold the combined Types
				Concatenate/T/NP {EventWv} , Event4Fit // Add the selected Event data wave to the wave created to hold the combined events
				DoAlert/T = "More Data?", 1, "Do you want to add more data?" // Check to see if the user wants to add another data set
				If( V_Flag > 1 ) // If the User answers "No", then Break out of the loop
					Break
				EndIf			
			EndFor		
		SetDataFolder root:
		KillWaves/Z DataTypeWv // Delete the Type wave since it was only created for the purpose of this function
	End