#pragma rtGlobals=3		// Use modern global access method and strict wave access.
	
	Function Append_Site_2_Site_Data()
		SetDataFolder root:
			PauseUpdate;
			String/G G_BaseSite, G_StretchSite, G_Technique, G_Data
			String BaseSite = G_BaseSite, StretchSite = G_StretchSite, Technique = G_Technique, Data = G_Data	
			Prompt BaseSite "BaseSite"
			Prompt StretchSite "StretchSite"
			Prompt Technique "Technique"
			Prompt Data "Data"
			DoPrompt "Append_Site_2_Site_Data" BaseSite, StretchSite, Technique, Data
			G_BaseSite = BaseSite; G_StretchSite = StretchSite; G_Data = Data; G_Technique = Technique
			AbortOnValue V_Flag, 0	
			String B_Data, B_CCSF, S_Data, S_CCSF, Folder	

			WAVE BaseTies, StretchTies, TieStr, DeltaTies
			WAVE/T TieType

		NewDataFolder/O/S $BaseSite + "_" + StretchSite + "_Results"
			DFREF ResultsFldr = GetDataFolderDFR( )
		SetDataFolder root:
		NewDataFolder/O/S Xtras
			DFREF XtrasFldr = GetDataFolderDFR( )
			Make/O/N=0  Ones, Numbers
		SetDataFolder $"root:" + StretchSite + "_" + Technique
			DFREF StrDataFldr = GetDataFolderDFR( )
		SetDataFolder $"root:" + BaseSite + "_" + Technique
			DFREF BaseDataFldr = GetDataFolderDFR( )

		SetDataFolder StrDataFldr
			WAVE StrSiteCCSF = $StretchSite + "S_" + Technique + "_CCSF"
			WAVE StrSiteData = $StretchSite + "S_" + Technique + "_" + Data
			If( !WaveExists( StrSiteData ) )
				SetDataFolder root:
				ABORT "This function uses the \"S\" identifier for spliced data and I can't find " + StretchSite + "S_" + Technique + "_" + Data + " in the " + StretchSite + "_" + Technique + " data folder.\r\rUse Batch_Rename_Waves to change \"_Splice\" to \"S\""
			Endif
		SetDataFolder BaseDataFldr
			WAVE BaseSiteData = $BaseSite + "S_" + Technique + "_" + Data
			WAVE BaseSiteCCSF = $BaseSite + "S_" + Technique + "_CCSF"
			If( !WaveExists( BaseSiteData ) )
				SetDataFolder root:
				ABORT "This function uses the \"S\" identifier for spliced data and I can't find " + BaseSite + "S_" + Technique + "_" + Data + " in the " + BaseSite + "_" + Technique + " data folder.\r\rUse Batch_Rename_Waves to change \"_Splice\" to \"S\""
			Endif
		
		SetDataFolder ResultsFldr
			Duplicate/O StrSiteCCSF $StretchSite + "S_" + Technique + "_CCSF" + BaseSite	
			WAVE StretchedCCSF = $StretchSite + "S_" + Technique + "_CCSF" + BaseSite
			StretchedCCSF = interp( StrSiteCCSF, StretchTies, BaseTies )
			If( Exists( BaseSite + "_2_" + StretchSite + "_Ties" ) )   // Copies existing Ties into generic BaseTies and StretchTies waves
				Duplicate/O $BaseSite + "_2_" + StretchSite + "_Ties" BaseTies
				Duplicate/O $StretchSite + "_2_" + BaseSite + "_Ties" StretchTies
				Duplicate/O BaseTies Ones, Numbers
				Ones = .5
				Numbers = x
			EndIf
		SetDataFolder root:
			String StrAxis = StretchSite+"_" +Data	
			String BaseAxis = BaseSite+"_" +Data	
			String StrDataAxis = StretchSite+"_"+Data+"_Stretched"
		SetDataFolder XtrasFldr
			String BaseValName = "Base_" + Data + "_Val"
			String StrValName = "Stretch_" + Data + "_Val"
			String BaseDataName = BaseSite + "S_" + Technique + "_" + Data
			String StrDataName = StretchSite + "S_" + Technique + "_" + Data
		
			AppendToGraph/T/R = $BaseAxis BaseSiteData vs BaseSiteCCSF	// Plots Base Site data on middle third of graph
			Label $BaseAxis "\\Z12\\f01" + BaseSite + " " + Data
			ModifyGraph lblPos( $BaseAxis ) = 70, freePos( $BaseAxis ) = 0
			ModifyGraph axisEnab( $BaseAxis ) = { .33, .66 }
	
			AppendToGraph/R = $StrAxis StrSiteData vs StrSiteCCSF	// Plots Stretch Site data on bottom third of graph
			Label $StrAxis "\\Z12\\f01" + StretchSite + " " + Data
			ModifyGraph lblPos( $StrAxis ) = 70, freePos( $StrAxis ) = 0
			ModifyGraph axisEnab( $StrAxis ) = { 0, .33 }
	
			AppendToGraph/T/R = $StrDataAxis StrSiteData vs StretchedCCSF	// Plots Stretched data on top third of graph
			Label $StrDataAxis "\\Z12\\f01Stretch_"+StretchSite+"_"+Data
			ModifyGraph lblPos( $StrDataAxis ) = 70, freePos( $StrDataAxis ) = 0
			ModifyGraph axisEnab( $StrDataAxis ) = { .66, 1 }
 
 		SetDataFolder root:
			If( NumPnts( BaseTies ) ) // This makes sure that if there are "old" ties, that the graph reflects those points.
				Site_2_Site_Data_Stretch_F( BaseSite, StretchSite, Technique, Data )
			EndIf
			SetAxis Bottom 0, 30; SetAxis/Z Top 0, 30;		
			Cursor A, $BaseSite + "S_" + Technique + "_" + Data, 15
			Cursor B, $StretchSite + "S_" + Technique + "_" + Data, 15
			Set_Cursors_Red( )
			Label Bottom "\\Z14Stretch Site Original Depth"
			Label Top "\\Z14Base Site & Stretched Depth"	
			ModifyGraph lblMargin(top)=10,lblMargin(bottom)=10
			ModifyGraph margin(bottom)=55,margin(top)=55
			ModifyGraph margin( Right ) = 65
			ModifyGraph lblPos( $BaseAxis ) = 55,lblPos( $StrAxis ) = 55, lblPos( $StrDataAxis ) = 55	
	End
	

