﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.



	Function CalculateSurfaceFit( Image, FitOrder )
			WAVE Image // The image to be corrected. It is a 2D image ( Red, Green, Blue layers of an RGB image )
			Variable FitOrder
		SetDataFolder root:
			Variable i
			WAVE WaveX, WaveY // These waves are formed before the function is run. They are the coordiantes of the points used for the correction surfaces
			Duplicate/O WaveX  WaveZ // WaveZ is the 0-255 level at each measurement point
			WaveZ = NaN
			For( i = 0; i < NumPnts( WaveX ); i += 1 )
					WaveZ[ i ] = Image[ WaveX[ i ] ][ WaveY[ i ] ] // Fill in the Z values
			EndFor
			Smooth/M=50 5, WaveZ // Apply a median filter to suppress outliers ( like when one of the X-Y points falls on black writing in the image
			CurveFit/Q poly2D FitOrder, waveZ /X = { WaveX, WaveY } // Fits a FitOrder ( normally 4 ) 2D polynomial to the X and Y points
			WAVE W_Coef // The coefficients of the curvefit
			Duplicate/O/RMD = [][][0] Image Surface // Surface is a fit to all of the points that should be at or around 245
			SurFace = poly2D(W_coef,x,y) // Calculates the surface for application in CoreTableCorrection()
			KillWaves/Z W_Coef, W_sigma, W_ParamConfidenceInterval
	End
	
