﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function MADJANUSDataLoader( )
		SetDataFolder root:
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "MADJANUSDataLoader", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "MADJANUSDataLoader_F(",CC_Replacement,")"
			MADJANUSDataLoader_F( CC_Replacement )
	End
	
	Function MADJANUSDataLoader_F( CC_Replacement )
			Variable CC_Replacement
			String Hole
		SetDataFolder root:
			String SiteNum
			WAVE/T H, TW, Method, Comments
			WAVE Cor, Sc, Top_cm_, Depth__mbsf_, BD__g_cc_, DD__g_cc_, GD__g_cc_, PO____, VR, Bot_cm_, Site, WW____, WD____, Leg
			If( !WaveExists( BD__g_cc_ ) )
				Print "I can't find the datawave \"BD__g_cc_\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are MAD3 data from JANUS?"
				ABORT "I can't find the datawave \"BD__g_cc_\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are MAD data from JANUS?"
			EndIf
			If( NumType( Cor[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1, Leg,Site,H,Cor,TW,Sc,Top_cm_,Bot_cm_,Depth__mbsf_,WW____,WD____,BD__g_cc_,DD__g_cc_,GD__g_cc_,PO____,VR,Method,Comments
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "BD__g_cc_", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			Hole = "U" + Num2Str( Site[ 0 ] ) + H[ 0 ]
			SiteNum = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteNum + "_MAD"
			Replace_NaNswithNumber_F( "Sc", CC_Replacement )
			Duplicate/O H, $":" + SiteNum + "_MAD:" + Hole + "_MAD_Hole"; 
			Duplicate/O Cor, $":" + SiteNum + "_MAD:" + Hole + "_MAD_Core"; 
			Duplicate/O TW, $":" + SiteNum + "_MAD:" + Hole + "_MAD_Type"; 
			Duplicate/O Sc, $":" + SiteNum + "_MAD:" + Hole + "_MAD_Section"; 
			Duplicate/O Top_cm_, $":" + SiteNum + "_MAD:" + Hole + "_MAD_Interval"; 
			Duplicate/O Depth__mbsf_, $":" + SiteNum + "_MAD:" + Hole + "_MAD_mbsf"; 
			Duplicate/O BD__g_cc_, $":" + SiteNum + "_MAD:" + Hole + "_MAD_RhoB"; 
			Duplicate/O DD__g_cc_, $":" + SiteNum + "_MAD:" + Hole + "_MAD_RhoD"
			Duplicate/O GD__g_cc_, $":" + SiteNum + "_MAD:" + Hole + "_MAD_RhoG"
			Duplicate/O PO____, $":" + SiteNum + "_MAD:" + Hole + "_MAD_Phi"
			Duplicate/O VR, $":" + SiteNum + "_MAD:" + Hole + "_MAD_VoidRatio"
			Duplicate/O H, $":" + SiteNum + "_MAD:" + Hole + "_MAD_Site"; 
			WAVE/T SiteWv = $":" + SiteNum + "_MAD:" + Hole + "_MAD_Site"
			SiteWv = SiteNum
			EmptyJANUSDataTable( )
			KillWaves H, TW, Method, Comments
			KillWaves Cor, Sc, Top_cm_, Depth__mbsf_, BD__g_cc_, DD__g_cc_, GD__g_cc_, PO____, VR, Bot_cm_, Site, WW____, WD____, Leg
	End

