﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function MSJANUSDataLoader( )
		SetDataFolder root:
			String SiteNum
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "MSJANUSDataLoader", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "MSJANUSDataLoader_F(",CC_Replacement,")"
			MSJANUSDataLoader_F( CC_Replacement )
	End
	
	Function MSJANUSDataLoader_F( CC_Replacement )
			Variable CC_Replacement
		SetDataFolder root:
			String SiteNum, Hole
			WAVE/T H, TW
			WAVE Leg,Site,Core,SecW,Top__cm_,Depth__mbsf_,Magnetic_Suscept_,Corrected_Suscept_
			If( !WaveExists( Magnetic_Suscept_ ) )
				Print "I can't find the datawave \"Magnetic_Suscept_\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are MS data from JANUS?"
				ABORT "I can't find the datawave \"Magnetic_Suscept_\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are MS data from JANUS?"
			EndIf
			If( NumType( Core[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1,   Leg,Site,H,Core,TW,SecW,Top__cm_,Depth__mbsf_,Magnetic_Suscept_,Corrected_Suscept_
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "Magnetic_Suscept_", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			Hole = "U" + Num2Str( Site[ 0 ] ) + H[ 0 ]
			SiteNum = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteNum + "_MS"
			Replace_NaNswithNumber_F( "SecW", CC_Replacement )
			Duplicate/O H, $":" + SiteNum + "_MS:" + Hole + "_MS_Hole"; 
			Duplicate/O Core, $":" + SiteNum + "_MS:" + Hole + "_MS_Core"; 
			Duplicate/O TW, $":" + SiteNum + "_MS:" + Hole + "_MS_Type"; 
			Duplicate/O SecW, $":" + SiteNum + "_MS:" + Hole + "_MS_Section"; 
			Duplicate/O Top__cm_, $":" + SiteNum + "_MS:" + Hole + "_MS_Interval"; 
			Duplicate/O Depth__mbsf_, $":" + SiteNum + "_MS:" + Hole + "_MS_mbsf"; 
			Duplicate/O Magnetic_Suscept_, $":" + SiteNum + "_MS:" + Hole + "_MS_MS"
			Duplicate/O Corrected_Suscept_, $":" + SiteNum + "_MS:" + Hole + "_MS_MSCorrected"
			Duplicate/O H, $":" + SiteNum + "_MS:" + Hole + "_MS_Site"; 
			WAVE/T SiteWv = $":" + SiteNum + "_MS:" + Hole + "_MS_Site"
			SiteWv = SiteNum
			EmptyJANUSDataTable( )
			KillWaves H, TW
			KillWaves Leg,Site,Core,SecW,Top__cm_,Depth__mbsf_,Magnetic_Suscept_,Corrected_Suscept_

			End
			