﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	
	Function MADBatchLoad()
		SetDataFolder root:
			KillPath/Z Data_Path
			KillVariables/Z Hole
			String DataFileList
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement, i
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is usual )" 
			DoPrompt "MADBatchLoad", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			DoAlert 0, "Select the folder holding the \".csv\" files."
			NewPath Data_Path
			DataFileList = IndexedFile( Data_Path, -1, ".csv" )
			If( StrLen( DataFileList ) == 0 )
				PathInfo Data_Path
				KillPath Data_Path
				ABORT "I can't find any \".csv\" files in \r\r  " + S_Path
			EndIf
			DoAlert 1, "This function will attempt to process all \".csv\" files in the selected folder. You will generate an error if there are non-MAD files.\r\rDo yu want to continue?"
			AbortOnValue V_Flag == 2, 0
			For( i = 0; i < ItemsInList( DataFileList ); i += 1 )
				LoadWave/A/P=Data_Path/Q/J/W/K=0/L={0,1,0,0,0}/v={",","\"",0,0} StringFromList( i, DataFileList )				
				WAVE/T Site,Hole,Type,A_W,Submethod,Text_ID,Test_comments,Sample_comments
				WAVE ExpW,Core,Sect,Offset__cm_,Depth_CSF_A__m_,Depth_CSF_B__m_,Moisture_dry__wt__,Moisture_wet__wt__
				WAVE Bulk_density__g_cm__,Dry_density__g_cm__,Grain_density__g_cm__,Porosity__vol__,Void_ratio,Container_number
				WAVE Mass_wet_sample__g_,Mass_dried_sample__g_,Mass_porewater__g_,Mass_salt__g_,Mass_solids__g_
				WAVE Vol_wet_sample__cm__,Vol_dried_sample__cm__,Vol_porewater__cm__,Vol_salt__cm__,Vol_solids__cm__,Timestamp__UTC_,Test_No_
				If( StrSearch( Site[ 0 ], "\"", 0 ) > -1 ) // This section takes care of the quotes in the downloaded data file if they are present
					String S2 = Site[0]; S2 = S2[ 1 , StrLen( S2 ) - 2 ]; Site = S2
					String H2 = Hole[0]; H2 = H2[ 1 , StrLen( H2 ) - 2 ]; Hole = H2
					String T2 = Type[0]; T2 = T2[ 1 , StrLen( T2 ) - 2 ]; Type = T2
				EndIf
				String H = Site[0] + Hole[0], SiteNum = RemoveEnding( H )
				Replace_NaNswithNumber_F( "Sect", CC_Replacement )
				NewDataFolder/O $SiteNum + "_MAD"
				Duplicate/O Site, $":" + SiteNum + "_MAD:" + H + "_MAD_Site"; 
				Duplicate/O Hole, $":" + SiteNum + "_MAD:" + H + "_MAD_Hole"; 
				Duplicate/O Core, $":" + SiteNum + "_MAD:" + H + "_MAD_Core"; 
				Duplicate/O Type, $":" + SiteNum + "_MAD:" + H + "_MAD_Type"; 
				Duplicate/O Sect, $":" + SiteNum + "_MAD:" + H + "_MAD_Section"; 
				Duplicate/O Offset__cm_, $":" + SiteNum + "_MAD:" + H + "_MAD_Interval"; 
				Duplicate/O Depth_CSF_A__m_, $":" + SiteNum + "_MAD:" + H + "_MAD_CSFA"; 
				Duplicate/O Bulk_density__g_cm__, $":" + SiteNum + "_MAD:" + H + "_MAD_RhoB"; 
				Duplicate/O Dry_density__g_cm__, $":" + SiteNum + "_MAD:" + H + "_MAD_RhoD"
				Duplicate/O Grain_density__g_cm__, $":" + SiteNum + "_MAD:" + H + "_MAD_RhoG"
				Duplicate/O Porosity__vol__, $":" + SiteNum + "_MAD:" + H + "_MAD_Phi"
				Duplicate/O Void_ratio, $":" + SiteNum + "_MAD:" + H + "_MAD_VoidRatio"
				KillWaves Site,Hole,Type,A_W,Submethod,Text_ID,Test_comments,Sample_comments
				KillWaves ExpW,Core,Sect,Offset__cm_,Depth_CSF_A__m_,Depth_CSF_B__m_,Moisture_dry__wt__,Moisture_wet__wt__
				KillWaves Bulk_density__g_cm__,Dry_density__g_cm__,Grain_density__g_cm__,Porosity__vol__,Void_ratio,Container_number
				KillWaves Mass_wet_sample__g_,Mass_dried_sample__g_,Mass_porewater__g_,Mass_salt__g_,Mass_solids__g_
				KillWaves Vol_wet_sample__cm__,Vol_dried_sample__cm__,Vol_porewater__cm__,Vol_salt__cm__,Vol_solids__cm__,Timestamp__UTC_,Test_No_
			EndFor
			KillPath Data_Path
	End


//	Function MADLOREDataLoader( )
		SetDataFolder root:
			String/G G_H
			String H = G_H, SiteNum
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt H, "Hole ( e.g. U1242A )"
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "MADLOREDataLoader", H, CC_Replacement
			G_H = H; G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "MADLOREDataLoader_F( \"" + H + "\",", CC_Replacement, ")"
			MADLOREDataLoader_F( H, CC_Replacement )
	End
	
//	Function MADLOREDataLoader_F( H, CC_Replacement )
			String H
			Variable CC_Replacement
			H = UpperStr( H )
			CheckHole4aU( H )
		SetDataFolder root:
			String SiteNum
			SiteNum = RemoveEnding( H )
			WAVE/T Site,Hole,Type,A_W,Submethod,Text_ID,Test_comments,Sample_comments
			WAVE ExpW,Core,Sect,Offset__cm_,Depth_CSF_A__m_,Depth_CSF_B__m_,Moisture_dry__wt__,Moisture_wet__wt__
			WAVE Bulk_density__g_cm__,Dry_density__g_cm__,Grain_density__g_cm__,Porosity__vol__,Void_ratio,Container_number
			WAVE Mass_wet_sample__g_,Mass_dried_sample__g_,Mass_porewater__g_,Mass_salt__g_,Mass_solids__g_
			WAVE Vol_wet_sample__cm__,Vol_dried_sample__cm__,Vol_porewater__cm__,Vol_salt__cm__,Vol_solids__cm__,Timestamp__UTC_,Test_No_
			If( !WaveExists( Bulk_density__g_cm__ ) )
				Print "I can't find the datawave \"Bulk_density__g_cm__\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are MAD data from LORE?"
				ABORT "I can't find the datawave \"Bulk_density__g_cm__\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are MAD data from LORE?"
			EndIf
			If( numtype( Core[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1, Site,Hole,Type,A_W,Submethod,Text_ID,Test_comments,Sample_comments
				DeletePoints 0,1, ExpW,Core,Sect,Offset__cm_,Depth_CSF_A__m_,Depth_CSF_B__m_,Moisture_dry__wt__,Moisture_wet__wt__
				DeletePoints 0,1, Bulk_density__g_cm__,Dry_density__g_cm__,Grain_density__g_cm__,Porosity__vol__,Void_ratio,Container_number
				DeletePoints 0,1, Mass_wet_sample__g_,Mass_dried_sample__g_,Mass_porewater__g_,Mass_salt__g_,Mass_solids__g_
				DeletePoints 0,1, Vol_wet_sample__cm__,Vol_dried_sample__cm__,Vol_porewater__cm__,Vol_salt__cm__,Vol_solids__cm__,Timestamp__UTC_,Test_No_
			EndIf
			If( !StringMatch( Hole[1], H[ StrLen( H ) - 1 ] ) ) // Checks to see that the data table has data from the designated Hole
				Print "The Hole in the data column is not the same as the Hole input.\r\t\t" + Site[1] + Hole[1] + " vs " + H 
				ABORT "The Hole in the data column is not the same as the Hole input.\r\r" + Site[1] + Hole[1] + " vs " + H 
			EndIf
			If( !StringMatch( Site[1], SiteNum ) )  // Checks to see that the data table has data from the designated Hole
				Print "The Site Number in the data column \"Site\" is not the same as the Site Number input.\r\t\t" + Site[1] + " vs " + SiteNum
				ABORT "The Site Number in the data column \"Site\" is not the same as the Site Number input.\r\r" + Site[1] + " vs " + SiteNum
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "LOREDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:LOREDataTable" ), "Bulk_density__g_cm__", 0 ) < 0 ) // Checks that the data are in the designated Table named "LOREDataTable"
				Print "The data are not in a table named \"LOREDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyLOREDataTable()\r\t\tfrom the LORE_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"LOREDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyLOREDataTable\"\r\rfrom the LORE_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			Replace_NaNswithNumber_F( "Sect", CC_Replacement )
			Rename Hole, $H + "_MAD_Hole"; 
			Rename Core, $H + "_MAD_Core"; 
			Rename Type, $H + "_MAD_Type"; 
			Rename Sect, $H + "_MAD_Section"; 
			Rename Offset__cm_, $H + "_MAD_Interval"; 
			Rename Depth_CSF_A__m_, $H + "_MAD_CSFA"; 
			Rename Bulk_density__g_cm__, $H + "_MAD_RhoB"; 
			Rename Dry_density__g_cm__, $H + "_MAD_RhoD"
			Rename Grain_density__g_cm__, $H + "_MAD_RhoG"
			Rename Porosity__vol__, $H + "_MAD_Phi"
			Rename Void_ratio, $H + "_MAD_VoidRatio"
			EmptyLOREDataTable( )
			NewDataFolder/O $SiteNum + "_MAD"
			KillWaves ExpW,Site,A_W,Depth_CSF_B__m_,Submethod,Moisture_dry__wt__,Moisture_wet__wt__,Container_number
			KillWaves Mass_wet_sample__g_,Mass_dried_sample__g_,Mass_porewater__g_,Mass_salt__g_,Mass_solids__g_
			KillWaves Vol_wet_sample__cm__,Vol_dried_sample__cm__,Vol_porewater__cm__,Vol_salt__cm__,Vol_solids__cm__
			KillWaves Timestamp__UTC_,Text_ID,Test_No_,Test_comments,Sample_comments
	End

