﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function RemoveSectionEndData()
		SetDataFolder root:
			Variable i
			String/G G_Folder, G_DataWaveName
			String Folder = G_Folder, DataWaveName  = G_DataWaveName		
			Prompt Folder, "Select the Data Folder:", popup, FolderList("*")
			DoPrompt "RemoveSectionEndData", Folder
			G_Folder = Folder; AbortOnValue V_Flag, 0
		SetDataFolder $Folder	
				// We select interval waves because they represent the distance along the core section
			Prompt DataWaveName, "Select the Data Interval Wave:", popup, WaveList( "*Interval", ";", "" )
			DoPrompt "RemoveSectionEndData", DataWaveName
			G_DataWaveName  = DataWaveName; AbortOnValue V_Flag, 0
			Print "RemoveSectionEndData_F( \"" + Folder + "\", \"" + DataWaveName + "\" )"
			RemoveSectionEndData_F( Folder, DataWaveName )


	End

---------------------------------------
	
	Function RemoveSectionEndData_F( Folder, DataWaveName )
		String Folder, DataWaveName
		SetDataFolder root:
			Variable i
		SetDataFolder $Folder	
			WAVE DataWave = $DataWaveName
			DataWave[ 0 ] = NaN									// First point in data set to zero
			DataWave[ NumPnts( DataWave )  - 1 ] = NaN	// Last point in data set to zero			
			For( i = 1; i < NumPnts( DataWave ); i += 1 )
				If( DataWave[ i ] <= 2.5 )							// If interval is at the top of the section
					DataWave[ i ] = NaN									//	set it to NaN as well as the data point
					DataWave[ i - 1 ] = NaN								// 	above it ( last point of precious section )
				EndIf
			EndFor
			WaveStats/Q DataWave //After setting the endpoints to NaN, find out how many NaNs and data points are left
			String HoleWaveList = WaveList( FirstPart( DataWaveName ) + "*", ";", "" )  // Form a list of waves from the selected Hole
			Sort_By_Data_F( FirstPart( DataWaveName ), SecondPart( DataWaveName ), "Interval" )
		SetDataFolder $Folder	  // Need to return to Folder as the sort routine resets to root:
			For( i = 0;  i < ItemsInList( HoleWaveList ); i += 1 ) // Go through all of the waves from the Hole and redimension them to exclude the NaNs
				Redimension/N = ( V_Npnts - 1 ) $StringFromList( i, HoleWaveList )
				Note $StringFromList( i, HoleWaveList ), "RemoveSectionEndData()" // Add a wavenote to the waves 
			EndFor
  			Sort_By_Core_F( FirstPart( DataWaveName ), SecondPart( DataWaveName ) ) // ReSort to core, section, interval
		SetDataFolder root:
	End

