﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	
	Function Site_2_Site_CSITieList()
		SetDataFolder root:
			Variable i = 0,  j = 0, k = 0,  m = 0, Int, Core, MCD
			String/G G_BaseSite, G_StretchSite, G_Folder
			String BaseSite = G_BaseSite, StretchSite = G_StretchSite, ResultsFldr = G_Folder
			Prompt BaseSite, "Base Site"
			Prompt StretchSite, "Stretch Site"
			Prompt ResultsFldr, "Results Folder", popup, FolderList( "Results" )
			DoPrompt "Site_2_Site_CSITieList", BaseSite, StretchSite, ResultsFldr
			G_BaseSite = BaseSite; G_StretchSite = StretchSite; G_Folder = ResultsFldr
			AbortOnValue V_Flag, 0
			String BaseSpliceFldr = "root:" + BaseSite + "_Splice_Intervals"
			String StretchSpliceFldr = "root:" + StretchSite + "_Splice_Intervals"
			If( !DataFolderExists( BaseSpliceFldr ) )
				ABORT "The Splice Interval data folder for " + BaseSite + " is missing."
			EndIf
			If( !DataFolderExists( StretchSpliceFldr ) )
				ABORT "The Splice Interval data folder for " + StretchSite + " is missing."
			EndIf
			If( !DataFolderExists( "Matrices" ) )
				ABORT "The Matrices folder is missing. If the coring matrices are in root:, make a new datafolder named \"Matrices\" and put the coring matrices inside."
			EndIf
		SetDataFolder $BaseSpliceFldr
			WAVE BaseCCSF_Bottom = CCSF_Bottom, BaseCCSF_Top = CCSF_Top
			WAVE BaseCore  = Core_Top
			WAVE/T BaseHole_Top = Hole_Top
		SetDataFolder $StretchSpliceFldr
			WAVE StretchCCSF_Bottom = CCSF_Bottom, StretchCCSF_Top = CCSF_Top
			WAVE StretchCore = Core_Top
			WAVE/T StretchHole_Top = Hole_Top
		SetDataFolder $"root:" + ResultsFldr
			WAVE BaseTieWv = $BaseSite + "_2_" + StretchSite + "_Ties"
			WAVE StrTieWv = $StretchSite + "_2_" + BaseSite + "_Ties"			
		SetDataFolder root:
		NewDataFolder/O/S $BaseSite + "_2_" + StretchSite + "_TieTable"
			Make/O/N = ( NumPnts( BaseTieWv ) ) $BaseSite + "Core", $BaseSite + "Sec", $BaseSite + "Int", $BaseSite + "CSF", $BaseSite + "CCSF"
			Make/O/N = ( NumPnts( BaseTieWv ) ) $StretchSite + "Core", $StretchSite + "Sec", $StretchSite + "Int", $StretchSite + "CSF", $StretchSite + "CCSF"
			WAVE BCore = $BaseSite + "Core", BSec = $BaseSite + "Sec", BInt = $BaseSite + "Int", BCSF = $BaseSite + "CSF", BCCSF = $BaseSite + "CCSF"
			WAVE SCore = $StretchSite + "Core", SSec = $StretchSite + "Sec", SInt = $StretchSite + "Int", SCSF = $StretchSite + "CSF", SCCSF = $StretchSite + "CCSF"
			Make/T/O/N = ( NumPnts( BaseTieWv ) ) $BaseSite + "Site", $BaseSite + "Hole", $StretchSite + "Site", $StretchSite + "Hole", TiesTo			
			WAVE/T BSite = $BaseSite + "Site", BHole = $BaseSite + "Hole", SSite = $StretchSite + "Site", SHole = $StretchSite + "Hole", TiesTo	
			TiesTo = "Ties To"; BSite = BaseSite, SSite = StretchSite	
		SetDataFolder root:
			For( m = 0; m < NumPnts( BaseTieWv ) ; m+= 1 )
				Duplicate/O BaseCCSF_Top Temp
				MCD = BaseTieWv[ m ]
				Temp = ( BaseCCSF_Bottom >= MCD ) &&  ( BaseCCSF_Top <= MCD )
				WaveStats/Q Temp				
				WAVE CMatrix = $":Matrices:" + BaseSite + BaseHole_Top[ V_MaxLoc ] +"_Coring_Matrix"
				Core = BaseCore[ V_MaxLoc ]
				For( j = 0; j < 10; j += 1 )
					If( CMatrix[ Core ][ j ][ 2 ] + CMatrix[ Core ][ j ][ 1 ] > MCD )
						Int = Round( ( MCD - CMatrix[ Core ][ ( j ) ][ 2 ] ) * 100 )	
						BHole[ m ] = BaseHole_Top[ V_MaxLoc ]; BCore[ m ] = Core; BSec[ m ] = j; 
						BInt[ m ] = Int; BCSF[ m ] = CMatrix[ Core ][ ( j ) ][ 0 ] + ( Int/100 ); BCCSF[ m ] = MCD	
						Break
					EndIf
				EndFor			
				Duplicate/O StretchCCSF_Top Temp
				MCD = StrTieWv[ m ]
				Temp = ( StretchCCSF_Bottom >= MCD ) &&  ( StretchCCSF_Top <= MCD )
				WaveStats/Q Temp				
				WAVE CMatrix = $":Matrices:" + StretchSite + StretchHole_Top[ V_MaxLoc ] +"_Coring_Matrix"
				Core = StretchCore[ V_MaxLoc ]
				For( j = 0; j < 10; j += 1 )
					If( CMatrix[ Core ][ j ][ 2 ] + CMatrix[ Core ][ j ][ 1 ] > MCD )
						Int = Round( ( MCD - CMatrix[ Core ][ ( j ) ][ 2 ] ) * 100 )	
						SHole[ m ] = StretchHole_Top[ V_MaxLoc ]; SCore[ m ] = Core; SSec[ m ] = j; 
						SInt[ m ] = Int; SCSF[ m ] = CMatrix[ Core ][ ( j ) ][ 0 ] + ( Int/100 ); SCCSF[ m ] = MCD	
						Break;
					EndIf
				EndFor
			EndFor
			
			Edit/W=(576,71,2090,468) BSite,BHole,BCore,BSec,BInt,BCSF,BCCSF,TiesTo,SSite,SHole
			AppendToTable SCore,SSec,SInt,SCSF,SCCSF
			ModifyTable format=1,size=14,alignment=1,digits=2
			ModifyTable format( BCSF )=3, format( BCCSF )=3, format( SCSF )=3, format( SCCSF )=3

		KillWaves/Z Temp	
	End
	
	*********************************************************
	
	Function TieCSI_From_CCSF( S_Hole, MCD )
		Variable MCD
		String S_Hole
		String Site = RemoveEnding( S_Hole )
		Variable i = 0, j =1, k = 0, Int
		NVAR V1 = root:G_V1; V1 = 0
		WAVE CMatrix = $S_Hole+"_Coring_Matrix"
		k = DimSize( $S_Hole + "_Coring_Matrix", 0 ) - 1
		Do
			j = 1
			Do
				If( CMatrix[ i ][ j ][ 2 ] + CMatrix[ i ][ j ][ 1 ] > MCD )
					Int = Round( ( MCD - CMatrix[ i ][ ( j ) ][ 2 ] ) * 100 )	
					Printf "\t TiesTo \t%s\t%s\t%d\tH", Site, S_Hole[ StrLen( S_Hole ) - 1 ], i
					Printf "\t %d\t  %.0f\t %.2f\t %.2f\r", j, Int, CMatrix[ i ][ j ][ 0 ] + Int / 100, MCD
					V1 = 1;
					Break;
				EndIf
				j += 1;
			While( j < 10 )
			If( V1 )
				Break;
				EndIf
			i += 1
		While( i < k )
	EndMacro
	
	*********************************************************
