#pragma rtGlobals=3		// Use modern global access method.
			
	Function Spectral_Poly_Fit()
		SetDataFolder root:
			PauseUpdate;
			String/G G_Age_Data, G_Depth_Data, G_Site, G_AgeFolder, G_YorN
			Variable/G G_Poly_Order
			String AgeFolder = G_AgeFolder
			Prompt AgeFolder, "Age Folder", popup, FolderList( "*" )
			DoPrompt "Poly_Fit", AgeFolder
			G_AgeFolder = AgeFolder	
			AbortOnValue V_Flag, 0	
		SetDataFolder $AgeFolder	
			String Age_Data = G_Age_Data, Depth_Data = G_Depth_Data, Site = G_Site, YorN = G_YorN
			Variable Poly_Order = G_Poly_Order, i
			Prompt Site, "Site"
			Prompt Age_Data, "Age_Data", popup, WaveList( "*", ";", "" )
			Prompt Depth_Data, "Depth_Data", popup, WaveList( "*", ";", "" )
			Prompt Poly_Order, "Polynomial Order ( 2 = linear, Use 0 for Point by Point ):"
			Prompt YorN, "Do you want to force the fit through 0 Age at 0 Depth?", popup, "Yes;No"
			DoPrompt "Spectral_Poly_Fit", Site, Age_Data, Depth_Data, Poly_Order, YorN
			G_Site = Site; G_Age_Data = Age_Data, G_Depth_Data = Depth_Data, G_Poly_Order = Poly_Order; G_YorN = YorN
			AbortOnValue V_Flag, 0
		SetDataFolder root:
			Spectral_Poly_Fit_F( AgeFolder, Site, Age_Data, Depth_Data, Poly_Order, YorN )
			Print "Spectral_Poly_Fit_F( " + "\"" + AgeFolder + "\", \"" + Site + "\", " + "\"" + Age_Data + "\", \"" + Depth_Data + "\", ", Poly_Order, ", \"" + YorN + "\" )"
	End
		
		-----------------------------------------------------------------------------------------------------
			
	Function Spectral_Poly_Fit_F( AgeFolder, Site, Age_Data, Depth_Data, Poly_Order, YorN )
			String AgeFolder, Age_Data, Depth_Data, Site, YorN
			Variable Poly_Order
		SetDataFolder root:
			Variable i
		SetDataFolder $AgeFolder
			WAVE AgeData = $Age_Data, DepthData = $Depth_Data
			Sort AgeData DepthData, AgeData
			If( !( StrSearch( WinList( "*", ";", "WIN:1" ) , "AgeVersusDepth", 0 ) + 1 )  )
				Age_Depth_Plot( AgeData, DepthData )
			EndIf
			Variable FitPoints = 500 // This sets how many points make up the fit curve
			If( Poly_Order == 0 )
				AgeModelCheck( Age_Data, Depth_Data )	
				FitPoints = 1000
				Interpolate2/T = 1 /N = ( FitPoints ) /Y = $"Fit_"+ Depth_Data AgeData, DepthData
			EndIf
			If( Poly_Order == 2 && StringMatch( YorN, "Yes" ) )
				k0 = 0
				CurveFit/Q/L = ( FitPoints )/H="10" line DepthData /X = AgeData /D 
			EndIf
			If( Poly_Order == 2 && StringMatch( YorN, "No" ) )
				CurveFit/Q/L = ( FitPoints ) line DepthData /X = AgeData /D 
			EndIf
			If( Poly_Order > 2 && StringMatch( YorN, "Yes" ) )
				k0 = 0
				CurveFit/Q/L = ( FitPoints )/H = "1000000000000000000000000"/NTHR=0 poly Poly_Order,  DepthData /X = AgeData /D
			EndIf
			If( Poly_Order > 2 && StringMatch( YorN, "No" ) )
				k0 = 0
				CurveFit/Q/L = ( FitPoints )/NTHR=0 poly Poly_Order,  DepthData /X = AgeData /D
			EndIf

			WAVE Depth_Fit = $"Fit_"+ Depth_Data
	
			Duplicate/O Depth_Fit fit_Age
			fit_Age = x
			
			KillWaves/Z M_Covar, W_Sigma, W_ParamConfidenceInterval, W_Coef


		NewDataFolder/O/S root:Poly_Predictions		// Make a new data folder for predictions of Milankovic curves based on sed rate 
				KillWaves/A/Z  // Get rid of existing calculated waves
				Differentiate Depth_Fit /D = $Site + "_PolySR"
				WAVE PolySR = $Site + "_PolySR", Period =$"root:Xtras:Period"
			If( Poly_Order == 2 )
				PolySR = Round( PolySR ) 
			EndIf
				For( i = 0; i < NumPnts( Period ); ++i )
					Make/O/N = ( FitPoints ) $"root:Poly_Predictions:Poly_" + Num2Str( Period[ i ] * 1000 ) + "k"
					WAVE P1 = $"Poly_" + Num2Str( Period[ i ] * 1000 ) + "k"
					P1 = 1 / ( PolySR * Period[ i ] )
				EndFor
				Make/O/N = ( FitPoints ) $Site + "_PolyAge",  $Site + "_PolyDepth"
				WAVE PolyAge = $Site + "_PolyAge", PolyDepth = $Site + "_PolyDepth"
				Interpolate2/T = 1/N = ( FitPoints ) /Y = PolyDepth /X = PolyAge Depth_Fit
				DoWindow/F AgeVersusDepth
				If( !StrLen( WaveList( Site + "_PolySR", ";", "Win:" ) ) )
					AppendToGraph/T PolyDepth vs PolySR
					Label top "Sedimentation Rate";DelayUpdate
					ModifyGraph axisEnab(top)={0.5,1}
					ModifyGraph lsize($Site + "_PolyDepth")=2,rgb($Site + "_PolyDepth")=(1,16019,65535)
				EndIf
			SetDataFolder root:
			Folder_WaveNotes_F( "Poly_Fit_F( " + "\"" + AgeFolder + "\", \"" + Site + "\", " + "\"" + Age_Data + "\", \"" + Depth_Data + "\", " + Num2Str( Poly_Order ) + " )", "Poly_Predictions", "Replace" )
	End
	
		-----------------------------------------------------------------------------------------------------
			
//	Function Spectral_Poly_Fit_F( AgeFolder, Site, Age_Data, Depth_Data, Poly_Order )
			String AgeFolder, Age_Data, Depth_Data, Site
			Variable Poly_Order
			Variable i
		SetDataFolder $AgeFolder	
			WAVE AgeData = $Age_Data, DepthData = $Depth_Data
			Sort AgeData DepthData, AgeData
			If( !( StrSearch( WinList( "*", ";", "WIN:1" ) , "AgeVersusDepth", 0 ) + 1 )  )
				Age_Depth_Plot( AgeData, DepthData )
			EndIf
			k0 = 0
			Variable FitPoints = 500 // This sets how many points make up the fit curve
			If( Poly_Order > 2 )
				CurveFit/Q/L = ( FitPoints )/H = "1000000000000000000000000"/NTHR=0 poly Poly_Order,  DepthData /X = AgeData /D
			Else
				CurveFit/Q/L = ( FitPoints )/H="10" line DepthData /X = AgeData /D 
			EndIf
			WAVE Depth_Fit = $"Fit_"+ Depth_Data
			
			Duplicate/O Depth_Fit fit_Age
			fit_Age = x
			
			KillWaves/Z M_Covar, W_Sigma, W_ParamConfidenceInterval, W_Coef
		NewDataFolder/O/S root:Poly_Predictions
				KillWaves/A/Z
				Differentiate Depth_Fit /D = $Site + "_PolySR"
				WAVE PolySR = $Site + "_PolySR", Period =$"root:Xtras:Period"
			If( Poly_Order == 2 )
				PolySR = Round( PolySR ) 
			EndIf
				For( i = 0; i < NumPnts( Period ); ++i )
					Make/O/N = ( FitPoints ) $"root:Poly_Predictions:Poly_" + Num2Str( Period[ i ] * 1000 ) + "k"
					WAVE P1 = $"Poly_" + Num2Str( Period[ i ] * 1000 ) + "k"
					P1 = 1 / ( PolySR * Period[ i ] )
				EndFor
				Make/O/N = ( FitPoints ) $Site + "_PolyAge",  $Site + "_PolyDepth"
				WAVE PolyAge = $Site + "_PolyAge", PolyDepth = $Site + "_PolyDepth"
				Interpolate2/T = 1/N = ( FitPoints ) /Y = PolyDepth /X = PolyAge Depth_Fit
				DoWindow/F AgeVersusDepth
				If( !StrLen( WaveList( Site + "_PolySR", ";", "Win:" ) ) )
					AppendToGraph/T PolyDepth vs PolySR
					Label top "Sedimentation Rate";DelayUpdate
					ModifyGraph axisEnab(top)={0.5,1}
					ModifyGraph lsize($Site + "_PolyDepth")=2,rgb($Site + "_PolyDepth")=(1,16019,65535)
				EndIf
			SetDataFolder root:
			Folder_WaveNotes_F( "Poly_Fit_F( " + "\"" + AgeFolder + "\", \"" + Site + "\", " + "\"" + Age_Data + "\", \"" + Depth_Data + "\", " + Num2Str( Poly_Order ) + " )", "Poly_Predictions", "Replace" )
	End
